blob: bf2d1ec899f03fc73315f5ade0d0efce926f955b [file] [log] [blame]
jeffhao5d1ac922011-09-29 17:41:15 -07001#!/bin/bash
2#
3# Copyright (C) 2007 The Android Open Source Project
4#
5# Licensed under the Apache License, Version 2.0 (the "License");
6# you may not use this file except in compliance with the License.
7# You may obtain a copy of the License at
8#
9# http://www.apache.org/licenses/LICENSE-2.0
10#
11# Unless required by applicable law or agreed to in writing, software
12# distributed under the License is distributed on an "AS IS" BASIS,
13# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
14# See the License for the specific language governing permissions and
15# limitations under the License.
16
17# Set up prog to be the path of this script, including following symlinks,
18# and set up progdir to be the fully-qualified pathname of its directory.
19prog="$0"
Andreas Gampedeb48a02014-10-22 00:44:35 -070020args="$@"
jeffhao5d1ac922011-09-29 17:41:15 -070021while [ -h "${prog}" ]; do
22 newProg=`/bin/ls -ld "${prog}"`
23 newProg=`expr "${newProg}" : ".* -> \(.*\)$"`
24 if expr "x${newProg}" : 'x/' >/dev/null; then
25 prog="${newProg}"
26 else
27 progdir=`dirname "${prog}"`
28 prog="${progdir}/${newProg}"
29 fi
30done
31oldwd=`pwd`
32progdir=`dirname "${prog}"`
33cd "${progdir}"
34progdir=`pwd`
35prog="${progdir}"/`basename "${prog}"`
Brian Carlstrom105215d2012-06-14 12:50:44 -070036test_dir="test-$$"
Andreas Gampe5a79fde2014-08-06 13:12:26 -070037if [ -z "$TMPDIR" ]; then
38 tmp_dir="/tmp/$USER/${test_dir}"
39else
Andreas Gampe34a8a0f2016-07-20 21:09:29 -070040 tmp_dir="${TMPDIR}/${test_dir}"
Andreas Gampe5a79fde2014-08-06 13:12:26 -070041fi
David Brazdil2c27f2c2015-05-12 18:06:38 +010042checker="${progdir}/../tools/checker/checker.py"
jeffhao5d1ac922011-09-29 17:41:15 -070043export JAVA="java"
Alex Lightea1e7702016-07-11 13:39:55 -070044export JAVAC="javac -g -Xlint:-options"
Nicolas Geoffray1a58b7f2014-10-06 12:23:04 +010045export RUN="${progdir}/etc/run-test-jar"
Brian Carlstrom105215d2012-06-14 12:50:44 -070046export DEX_LOCATION=/data/run-test/${test_dir}
Elliott Hughesc717eef2012-06-15 16:01:26 -070047export NEED_DEX="true"
Nicolas Geoffray1c5b6da2016-03-16 10:55:57 +000048export USE_JACK="true"
Igor Murashkin2a337752017-06-16 14:34:40 +000049export USE_DESUGAR="true"
Ben Gruver14fc9db2017-04-28 15:30:49 -070050export SMALI_ARGS=""
jeffhao5d1ac922011-09-29 17:41:15 -070051
Tsu Chiang Chuang4407e612012-07-19 16:13:43 -070052# If dx was not set by the environment variable, assume it is in the path.
53if [ -z "$DX" ]; then
54 export DX="dx"
55fi
56
Tsu Chiang Chuang6674f8a2013-01-16 15:41:21 -080057# If jasmin was not set by the environment variable, assume it is in the path.
58if [ -z "$JASMIN" ]; then
59 export JASMIN="jasmin"
60fi
61
Andreas Gampe8fda9f22014-10-03 16:15:37 -070062# If smali was not set by the environment variable, assume it is in the path.
63if [ -z "$SMALI" ]; then
64 export SMALI="smali"
65fi
66
67# If dexmerger was not set by the environment variable, assume it is in the path.
68if [ -z "$DXMERGER" ]; then
69 export DXMERGER="dexmerger"
70fi
71
Sebastien Hertz19ac0272015-02-24 17:39:50 +010072# If jack was not set by the environment variable, assume it is in the path.
73if [ -z "$JACK" ]; then
74 export JACK="jack"
75fi
76
Sebastien Hertz19ac0272015-02-24 17:39:50 +010077# ANDROID_BUILD_TOP is not set in a build environment.
78if [ -z "$ANDROID_BUILD_TOP" ]; then
79 export ANDROID_BUILD_TOP=$oldwd
80fi
81
Andreas Gampef47fb2f2016-06-24 22:30:29 -070082# ANDROID_HOST_OUT is not set in a build environment.
83if [ -z "$ANDROID_HOST_OUT" ]; then
Dan Willemsenf325e012017-03-03 12:35:30 -080084 export ANDROID_HOST_OUT=${OUT_DIR:-$ANDROID_BUILD_TOP/out}/host/linux-x86
Andreas Gampef47fb2f2016-06-24 22:30:29 -070085fi
86
Sebastien Hertz19ac0272015-02-24 17:39:50 +010087# If JACK_CLASSPATH is not set, assume it only contains core-libart.
88if [ -z "$JACK_CLASSPATH" ]; then
Andreas Gampef47fb2f2016-06-24 22:30:29 -070089 export JACK_CLASSPATH="${ANDROID_HOST_OUT}/../common/obj/JAVA_LIBRARIES/core-libart-hostdex_intermediates/classes.jack:${ANDROID_HOST_OUT}/../common/obj/JAVA_LIBRARIES/core-oj-hostdex_intermediates/classes.jack"
Sebastien Hertz19ac0272015-02-24 17:39:50 +010090fi
91
Sebastien Hertz19ac0272015-02-24 17:39:50 +010092export JACK="$JACK -g -cp $JACK_CLASSPATH"
Tsu Chiang Chuang6674f8a2013-01-16 15:41:21 -080093
Igor Murashkine5181932017-06-15 16:03:50 -070094# Allow changing DESUGAR script to something else, or to disable it with DESUGAR=false.
Igor Murashkind3232772017-06-22 14:54:13 -070095if [ -z "$DESUGAR" ]; then
Igor Murashkine5181932017-06-15 16:03:50 -070096 export DESUGAR="$ANDROID_BUILD_TOP/art/tools/desugar.sh"
97fi
98
Igor Murashkin271a0f82017-02-14 21:14:17 +000099# Zipalign is not on the PATH in some configs, auto-detect it.
100if [ -z "$ZIPALIGN" ]; then
101 if which zipalign >/dev/null; then
102 ZIPALIGN="zipalign";
103 else
104 # TODO: Add a dependency for zipalign in Android.run-test.mk
105 # once it doesn't depend on libandroidfw (b/35246701)
106 case "$OSTYPE" in
107 darwin*) ZIPALIGN="$ANDROID_BUILD_TOP/prebuilts/sdk/tools/darwin/bin/zipalign" ;;
108 linux*) ZIPALIGN="$ANDROID_BUILD_TOP/prebuilts/sdk/tools/linux/bin/zipalign" ;;
109 *) echo "Can't find zipalign: unknown: $OSTYPE" >&2;;
110 esac
111 fi
112fi
113export ZIPALIGN
114
jeffhao5d1ac922011-09-29 17:41:15 -0700115info="info.txt"
116build="build"
117run="run"
118expected="expected.txt"
Andreas Gampe1c83cbc2014-07-22 18:52:29 -0700119check_cmd="check"
jeffhao5d1ac922011-09-29 17:41:15 -0700120output="output.txt"
121build_output="build-output.txt"
David Brazdil24128c62015-05-21 12:06:13 +0100122cfg_output="graph.cfg"
Hiroshi Yamauchi1d4184d2015-07-13 17:11:22 -0700123strace_output="strace-output.txt"
Brian Carlstromdc959ea2013-10-28 00:44:49 -0700124lib="libartd.so"
Mathieu Chartier031768a2015-08-27 10:25:02 -0700125testlib="arttestd"
jeffhao5d1ac922011-09-29 17:41:15 -0700126run_args="--quiet"
David Brazdil4846d132015-01-15 19:07:08 +0000127build_args=""
jeffhao5d1ac922011-09-29 17:41:15 -0700128
Alex Light91de25f2015-10-28 17:00:06 -0700129quiet="no"
Nicolas Geoffraya3d90fb2015-03-16 13:55:40 +0000130debuggable="no"
Alex Light9d722532014-07-22 18:07:12 -0700131prebuild_mode="yes"
Brian Carlstrom2613de42012-06-15 17:37:16 -0700132target_mode="yes"
jeffhao5d1ac922011-09-29 17:41:15 -0700133dev_mode="no"
134update_mode="no"
Alex Lighta59dd802014-07-02 16:28:08 -0700135debug_mode="no"
Nicolas Geoffray94e25db2017-01-27 14:54:28 +0000136relocate="no"
Jeff Hao201803f2013-11-20 18:11:39 -0800137runtime="art"
jeffhao5d1ac922011-09-29 17:41:15 -0700138usage="no"
Tsu Chiang Chuang011fade2012-07-09 18:34:47 -0700139build_only="no"
Andreas Gampe2fe07922014-04-21 07:50:39 -0700140suffix64=""
Jeff Hao85139a32014-07-23 11:52:52 -0700141trace="false"
Andreas Gampe7526d782015-06-22 22:53:45 -0700142trace_stream="false"
Alex Lighte7873ec2014-08-12 09:53:50 -0700143basic_verify="false"
144gc_verify="false"
145gc_stress="false"
Alex Lightb7edcda2017-04-27 13:20:31 -0700146jvmti_trace_stress="false"
147jvmti_redefine_stress="false"
Hiroshi Yamauchi1d4184d2015-07-13 17:11:22 -0700148strace="false"
Alex Lightbfac14a2014-07-30 09:41:21 -0700149always_clean="no"
Igor Murashkin05f30e12015-06-10 15:57:17 -0700150never_clean="no"
Alex Light03a112d2014-08-25 13:25:56 -0700151have_dex2oat="yes"
152have_patchoat="yes"
153have_image="yes"
Jeff Haodcdc85b2015-12-04 14:06:18 -0800154multi_image_suffix=""
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000155android_root="/system"
Wojciech Staszkiewiczd7a819a2016-09-01 14:43:39 -0700156bisection_search="no"
Mathieu Chartier3fceaf52017-01-22 13:33:40 -0800157suspend_timeout="500000"
Alex Light10bc5a42016-05-10 10:01:22 -0700158# By default we will use optimizing.
159image_args=""
Nicolas Geoffrayb76bc782016-09-14 12:33:34 +0000160image_suffix=""
jeffhao5d1ac922011-09-29 17:41:15 -0700161
162while true; do
163 if [ "x$1" = "x--host" ]; then
Brian Carlstrom2613de42012-06-15 17:37:16 -0700164 target_mode="no"
TDYa127b92bcab2012-04-08 00:09:51 -0700165 DEX_LOCATION=$tmp_dir
Nicolas Geoffray1a58b7f2014-10-06 12:23:04 +0100166 run_args="${run_args} --host"
jeffhao5d1ac922011-09-29 17:41:15 -0700167 shift
Alex Light91de25f2015-10-28 17:00:06 -0700168 elif [ "x$1" = "x--quiet" ]; then
169 quiet="yes"
170 shift
Alex Lighteb7c1442015-08-31 13:17:42 -0700171 elif [ "x$1" = "x--use-java-home" ]; then
172 if [ -n "${JAVA_HOME}" ]; then
173 export JAVA="${JAVA_HOME}/bin/java"
174 export JAVAC="${JAVA_HOME}/bin/javac -g"
175 else
176 echo "Passed --use-java-home without JAVA_HOME variable set!"
177 usage="yes"
178 fi
179 shift
Elliott Hughes58bcc402012-02-14 14:10:10 -0800180 elif [ "x$1" = "x--jvm" ]; then
Brian Carlstrom2613de42012-06-15 17:37:16 -0700181 target_mode="no"
Alex Light2c7aaeb2017-01-27 14:08:17 -0800182 DEX_LOCATION="$tmp_dir"
Jeff Hao201803f2013-11-20 18:11:39 -0800183 runtime="jvm"
Alex Lightbc90d0f2016-05-09 16:21:09 -0700184 image_args=""
Brian Carlstrom01afdba2014-10-03 10:28:47 -0700185 prebuild_mode="no"
Elliott Hughesc717eef2012-06-15 16:01:26 -0700186 NEED_DEX="false"
Sebastien Hertz19ac0272015-02-24 17:39:50 +0100187 USE_JACK="false"
Nicolas Geoffray288a4a22014-10-07 11:02:40 +0100188 run_args="${run_args} --jvm"
Alex Lighteb7c1442015-08-31 13:17:42 -0700189 build_args="${build_args} --jvm"
jeffhao5d1ac922011-09-29 17:41:15 -0700190 shift
Elliott Hughes58bcc402012-02-14 14:10:10 -0800191 elif [ "x$1" = "x-O" ]; then
Brian Carlstromdc959ea2013-10-28 00:44:49 -0700192 lib="libart.so"
Mathieu Chartier031768a2015-08-27 10:25:02 -0700193 testlib="arttest"
Alex Lightfaf90b62016-08-12 14:43:48 -0700194 run_args="${run_args} -O"
Brian Carlstromdc959ea2013-10-28 00:44:49 -0700195 shift
196 elif [ "x$1" = "x--dalvik" ]; then
197 lib="libdvm.so"
Jeff Hao201803f2013-11-20 18:11:39 -0800198 runtime="dalvik"
Brian Carlstromdc959ea2013-10-28 00:44:49 -0700199 shift
Alex Light03a112d2014-08-25 13:25:56 -0700200 elif [ "x$1" = "x--no-dex2oat" ]; then
201 have_dex2oat="no"
202 shift
203 elif [ "x$1" = "x--no-patchoat" ]; then
204 have_patchoat="no"
205 shift
206 elif [ "x$1" = "x--no-image" ]; then
207 have_image="no"
208 shift
Jeff Haodcdc85b2015-12-04 14:06:18 -0800209 elif [ "x$1" = "x--multi-image" ]; then
210 multi_image_suffix="-multi"
211 shift
Andreas Gampec23c9c92014-10-28 14:47:25 -0700212 elif [ "x$1" = "x--pic-test" ]; then
213 run_args="${run_args} --pic-test"
214 shift
Alex Lighta59dd802014-07-02 16:28:08 -0700215 elif [ "x$1" = "x--relocate" ]; then
216 relocate="yes"
217 shift
218 elif [ "x$1" = "x--no-relocate" ]; then
219 relocate="no"
220 shift
221 elif [ "x$1" = "x--prebuild" ]; then
Nicolas Geoffray5fd18ba2014-10-03 12:08:38 +0100222 run_args="${run_args} --prebuild"
Alex Lighta59dd802014-07-02 16:28:08 -0700223 prebuild_mode="yes"
224 shift;
Richard Uhler76f5cb62016-04-04 13:30:16 -0700225 elif [ "x$1" = "x--strip-dex" ]; then
226 run_args="${run_args} --strip-dex"
227 shift;
Nicolas Geoffray43c162f2015-03-09 12:21:26 +0000228 elif [ "x$1" = "x--debuggable" ]; then
229 run_args="${run_args} -Xcompiler-option --debuggable"
Nicolas Geoffraya3d90fb2015-03-16 13:55:40 +0000230 debuggable="yes"
Nicolas Geoffray43c162f2015-03-09 12:21:26 +0000231 shift;
Alex Lighta59dd802014-07-02 16:28:08 -0700232 elif [ "x$1" = "x--no-prebuild" ]; then
Nicolas Geoffray5fd18ba2014-10-03 12:08:38 +0100233 run_args="${run_args} --no-prebuild"
Alex Lighta59dd802014-07-02 16:28:08 -0700234 prebuild_mode="no"
235 shift;
Alex Lighte7873ec2014-08-12 09:53:50 -0700236 elif [ "x$1" = "x--gcverify" ]; then
237 basic_verify="true"
238 gc_verify="true"
239 shift
240 elif [ "x$1" = "x--gcstress" ]; then
241 basic_verify="true"
242 gc_stress="true"
243 shift
Alex Lightb7edcda2017-04-27 13:20:31 -0700244 elif [ "x$1" = "x--jvmti-redefine-stress" ]; then
245 jvmti_redefine_stress="true"
246 shift
247 elif [ "x$1" = "x--jvmti-trace-stress" ]; then
248 jvmti_trace_stress="true"
Alex Light8f2c6d42017-04-10 16:27:35 -0700249 shift
Mathieu Chartier3fceaf52017-01-22 13:33:40 -0800250 elif [ "x$1" = "x--suspend-timeout" ]; then
251 shift
252 suspend_timeout="$1"
253 shift
Brian Carlstromdc959ea2013-10-28 00:44:49 -0700254 elif [ "x$1" = "x--image" ]; then
255 shift
256 image="$1"
257 run_args="${run_args} --image $image"
Elliott Hughes7c046102011-10-19 18:16:03 -0700258 shift
Nicolas Geoffray92cf83e2014-03-18 17:59:20 +0000259 elif [ "x$1" = "x-Xcompiler-option" ]; then
260 shift
261 option="$1"
262 run_args="${run_args} -Xcompiler-option $option"
263 shift
Orion Hodsone1fb77f2017-02-27 13:57:18 +0000264 elif [ "x$1" = "x--build-option" ]; then
265 shift
266 option="$1"
267 build_args="${build_args} $option"
268 shift
Mathieu Chartier769a5ad2014-05-18 15:30:10 -0700269 elif [ "x$1" = "x--runtime-option" ]; then
270 shift
271 option="$1"
272 run_args="${run_args} --runtime-option $option"
273 shift
Mathieu Chartierc0a8a802014-10-17 15:58:01 -0700274 elif [ "x$1" = "x--gdb-arg" ]; then
275 shift
276 gdb_arg="$1"
277 run_args="${run_args} --gdb-arg $gdb_arg"
278 shift
jeffhao5d1ac922011-09-29 17:41:15 -0700279 elif [ "x$1" = "x--debug" ]; then
280 run_args="${run_args} --debug"
281 shift
282 elif [ "x$1" = "x--gdb" ]; then
283 run_args="${run_args} --gdb"
284 dev_mode="yes"
285 shift
Hiroshi Yamauchi1d4184d2015-07-13 17:11:22 -0700286 elif [ "x$1" = "x--strace" ]; then
287 strace="yes"
Mathieu Chartier2576be22016-05-24 10:24:53 -0700288 run_args="${run_args} --timeout 1800 --invoke-with strace --invoke-with -o --invoke-with $tmp_dir/$strace_output"
Hiroshi Yamauchi1d4184d2015-07-13 17:11:22 -0700289 shift
jeffhao5d1ac922011-09-29 17:41:15 -0700290 elif [ "x$1" = "x--zygote" ]; then
291 run_args="${run_args} --zygote"
292 shift
jeffhao0dff3f42012-11-20 15:13:43 -0800293 elif [ "x$1" = "x--interpreter" ]; then
Nicolas Geoffray4650c932016-05-10 09:13:13 +0000294 run_args="${run_args} --interpreter"
Andreas Gampe63fc30e2014-10-24 21:58:16 -0700295 image_suffix="-interpreter"
296 shift
Mathieu Chartiere5f13e52015-02-24 09:37:21 -0800297 elif [ "x$1" = "x--jit" ]; then
Alex Light10bc5a42016-05-10 10:01:22 -0700298 image_args="--jit"
Nicolas Geoffrayb76bc782016-09-14 12:33:34 +0000299 image_suffix="-interpreter"
Mathieu Chartiere5f13e52015-02-24 09:37:21 -0800300 shift
Andreas Gampe63fc30e2014-10-24 21:58:16 -0700301 elif [ "x$1" = "x--optimizing" ]; then
Alex Light10bc5a42016-05-10 10:01:22 -0700302 image_args="-Xcompiler-option --compiler-backend=Optimizing"
jeffhao0dff3f42012-11-20 15:13:43 -0800303 shift
jeffhao5d1ac922011-09-29 17:41:15 -0700304 elif [ "x$1" = "x--no-verify" ]; then
Richard Uhlerf4b34872016-04-13 11:03:46 -0700305 run_args="${run_args} --no-verify"
jeffhao5d1ac922011-09-29 17:41:15 -0700306 shift
Igor Murashkin7617abd2015-07-10 18:27:47 -0700307 elif [ "x$1" = "x--verify-soft-fail" ]; then
Alex Light10bc5a42016-05-10 10:01:22 -0700308 image_args="--verify-soft-fail"
Andreas Gampe825570c2015-07-26 10:26:03 -0700309 image_suffix="-interp-ac"
Igor Murashkin7617abd2015-07-10 18:27:47 -0700310 shift
jeffhao5d1ac922011-09-29 17:41:15 -0700311 elif [ "x$1" = "x--no-optimize" ]; then
312 run_args="${run_args} --no-optimize"
313 shift
314 elif [ "x$1" = "x--no-precise" ]; then
315 run_args="${run_args} --no-precise"
316 shift
Elliott Hughes7c046102011-10-19 18:16:03 -0700317 elif [ "x$1" = "x--invoke-with" ]; then
318 shift
319 what="$1"
Brian Carlstromdc959ea2013-10-28 00:44:49 -0700320 if [ "x$what" = "x" ]; then
321 echo "$0 missing argument to --invoke-with" 1>&2
322 usage="yes"
323 break
324 fi
Ian Rogers0e033672013-04-19 10:22:46 -0700325 run_args="${run_args} --invoke-with ${what}"
jeffhao5d1ac922011-09-29 17:41:15 -0700326 shift
327 elif [ "x$1" = "x--dev" ]; then
328 run_args="${run_args} --dev"
329 dev_mode="yes"
330 shift
Tsu Chiang Chuang011fade2012-07-09 18:34:47 -0700331 elif [ "x$1" = "x--build-only" ]; then
332 build_only="yes"
333 shift
Sebastien Hertz19ac0272015-02-24 17:39:50 +0100334 elif [ "x$1" = "x--build-with-javac-dx" ]; then
335 USE_JACK="false"
336 shift
337 elif [ "x$1" = "x--build-with-jack" ]; then
338 USE_JACK="true"
339 shift
Tsu Chiang Chuang011fade2012-07-09 18:34:47 -0700340 elif [ "x$1" = "x--output-path" ]; then
341 shift
342 tmp_dir=$1
Brian Carlstromdc959ea2013-10-28 00:44:49 -0700343 if [ "x$tmp_dir" = "x" ]; then
344 echo "$0 missing argument to --output-path" 1>&2
345 usage="yes"
346 break
347 fi
Tsu Chiang Chuang011fade2012-07-09 18:34:47 -0700348 shift
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000349 elif [ "x$1" = "x--android-root" ]; then
350 shift
351 if [ "x$1" = "x" ]; then
352 echo "$0 missing argument to --android-root" 1>&2
353 usage="yes"
354 break
355 fi
356 android_root="$1"
357 run_args="${run_args} --android-root $1"
358 shift
jeffhao5d1ac922011-09-29 17:41:15 -0700359 elif [ "x$1" = "x--update" ]; then
360 update_mode="yes"
361 shift
362 elif [ "x$1" = "x--help" ]; then
363 usage="yes"
364 shift
Andreas Gampeafbaa1a2014-03-25 18:09:32 -0700365 elif [ "x$1" = "x--64" ]; then
366 run_args="${run_args} --64"
Andreas Gampe2fe07922014-04-21 07:50:39 -0700367 suffix64="64"
Andreas Gampeafbaa1a2014-03-25 18:09:32 -0700368 shift
Sebastien Hertz07aaac82014-07-09 15:59:05 +0200369 elif [ "x$1" = "x--trace" ]; then
Jeff Hao85139a32014-07-23 11:52:52 -0700370 trace="true"
Sebastien Hertz07aaac82014-07-09 15:59:05 +0200371 shift
Andreas Gampe7526d782015-06-22 22:53:45 -0700372 elif [ "x$1" = "x--stream" ]; then
373 trace_stream="true"
374 shift
Alex Lightbfac14a2014-07-30 09:41:21 -0700375 elif [ "x$1" = "x--always-clean" ]; then
376 always_clean="yes"
377 shift
Igor Murashkin05f30e12015-06-10 15:57:17 -0700378 elif [ "x$1" = "x--never-clean" ]; then
379 never_clean="yes"
380 shift
Andreas Gampee21dc3d2014-12-08 16:59:43 -0800381 elif [ "x$1" = "x--dex2oat-swap" ]; then
382 run_args="${run_args} --dex2oat-swap"
383 shift
Andreas Gampe4d2ef332015-08-05 09:24:45 -0700384 elif [ "x$1" = "x--instruction-set-features" ]; then
385 shift
386 run_args="${run_args} --instruction-set-features $1"
387 shift
Wojciech Staszkiewiczd7a819a2016-09-01 14:43:39 -0700388 elif [ "x$1" = "x--bisection-search" ]; then
389 bisection_search="yes"
390 shift
Nicolas Geoffrayb0bbe8e2016-11-19 10:42:37 +0000391 elif [ "x$1" = "x--vdex" ]; then
392 run_args="${run_args} --vdex"
393 shift
Nicolas Geoffray74981052017-01-16 17:54:09 +0000394 elif [ "x$1" = "x--vdex-filter" ]; then
395 shift
396 filter=$1
397 run_args="${run_args} --vdex-filter $filter"
398 shift
Jeff Hao002b9312017-03-27 16:23:08 -0700399 elif [ "x$1" = "x--random-profile" ]; then
400 run_args="${run_args} --random-profile"
401 shift
jeffhao5d1ac922011-09-29 17:41:15 -0700402 elif expr "x$1" : "x--" >/dev/null 2>&1; then
Elliott Hughes7c046102011-10-19 18:16:03 -0700403 echo "unknown $0 option: $1" 1>&2
jeffhao5d1ac922011-09-29 17:41:15 -0700404 usage="yes"
405 break
406 else
407 break
408 fi
409done
Andreas Gampe3a12cfe2014-08-13 15:40:22 -0700410
Alex Light10bc5a42016-05-10 10:01:22 -0700411run_args="${run_args} ${image_args}"
Alex Light91de25f2015-10-28 17:00:06 -0700412# Allocate file descriptor real_stderr and redirect it to the shell's error
413# output (fd 2).
414if [ ${BASH_VERSINFO[1]} -ge 4 ] && [ ${BASH_VERSINFO[2]} -ge 1 ]; then
415 exec {real_stderr}>&2
416else
417 # In bash before version 4.1 we need to do a manual search for free file
418 # descriptors.
419 FD=3
420 while [ -e /dev/fd/$FD ]; do FD=$((FD + 1)); done
421 real_stderr=$FD
422 eval "exec ${real_stderr}>&2"
423fi
424if [ "$quiet" = "yes" ]; then
425 # Force the default standard output and error to go to /dev/null so we will
426 # not print them.
427 exec 1>/dev/null
428 exec 2>/dev/null
429fi
430
431function err_echo() {
432 echo "$@" 1>&${real_stderr}
433}
434
Andreas Gampe3a12cfe2014-08-13 15:40:22 -0700435# tmp_dir may be relative, resolve.
436#
437# Cannot use realpath, as it does not exist on Mac.
438# Cannot us a simple "cd", as the path might not be created yet.
Brian Carlstromc580e042014-09-08 21:37:39 -0700439# Cannot use readlink -m, as it does not exist on Mac.
440# Fallback to nuclear option:
Andreas Gampe907b6992014-08-18 22:26:49 -0700441noncanonical_tmp_dir=$tmp_dir
Brian Carlstromc580e042014-09-08 21:37:39 -0700442tmp_dir="`cd $oldwd ; python -c "import os; print os.path.realpath('$tmp_dir')"`"
Dmitry Petrochenko81c56e72014-03-05 15:05:46 +0700443mkdir -p $tmp_dir
jeffhao5d1ac922011-09-29 17:41:15 -0700444
Mathieu Chartier3fceaf52017-01-22 13:33:40 -0800445# Add thread suspend timeout flag
Narayan Kamathf86c3932017-01-24 17:40:47 +0000446if [ ! "$runtime" = "jvm" ]; then
447 run_args="${run_args} --runtime-option -XX:ThreadSuspendTimeout=$suspend_timeout"
448fi
Mathieu Chartier3fceaf52017-01-22 13:33:40 -0800449
Alex Lighte7873ec2014-08-12 09:53:50 -0700450if [ "$basic_verify" = "true" ]; then
Hiroshi Yamauchi312baf12015-01-12 12:11:05 -0800451 # Set HspaceCompactForOOMMinIntervalMs to zero to run hspace compaction for OOM more frequently in tests.
452 run_args="${run_args} --runtime-option -Xgc:preverify --runtime-option -Xgc:postverify --runtime-option -XX:HspaceCompactForOOMMinIntervalMs=0"
Alex Lighte7873ec2014-08-12 09:53:50 -0700453fi
454if [ "$gc_verify" = "true" ]; then
455 run_args="${run_args} --runtime-option -Xgc:preverify_rosalloc --runtime-option -Xgc:postverify_rosalloc"
456fi
457if [ "$gc_stress" = "true" ]; then
Mathieu Chartierd9eb2842016-08-12 16:11:24 -0700458 run_args="${run_args} --gc-stress --runtime-option -Xgc:gcstress --runtime-option -Xms2m --runtime-option -Xmx16m"
Alex Lighte7873ec2014-08-12 09:53:50 -0700459fi
Alex Lightb7edcda2017-04-27 13:20:31 -0700460if [ "$jvmti_redefine_stress" = "true" ]; then
461 run_args="${run_args} --no-app-image --jvmti-redefine-stress"
462fi
463if [ "$jvmti_trace_stress" = "true" ]; then
464 run_args="${run_args} --no-app-image --jvmti-trace-stress"
Alex Light8f2c6d42017-04-10 16:27:35 -0700465fi
Jeff Hao85139a32014-07-23 11:52:52 -0700466if [ "$trace" = "true" ]; then
Andreas Gampe7526d782015-06-22 22:53:45 -0700467 run_args="${run_args} --runtime-option -Xmethod-trace --runtime-option -Xmethod-trace-file-size:2000000"
468 if [ "$trace_stream" = "true" ]; then
469 # Streaming mode uses the file size as the buffer size. So output gets really large. Drop
470 # the ability to analyze the file and just write to /dev/null.
471 run_args="${run_args} --runtime-option -Xmethod-trace-file:/dev/null"
472 # Enable streaming mode.
473 run_args="${run_args} --runtime-option -Xmethod-trace-stream"
474 else
475 run_args="${run_args} --runtime-option -Xmethod-trace-file:${DEX_LOCATION}/trace.bin"
476 fi
477elif [ "$trace_stream" = "true" ]; then
Alex Light91de25f2015-10-28 17:00:06 -0700478 err_echo "Cannot use --stream without --trace."
Andreas Gampe7526d782015-06-22 22:53:45 -0700479 exit 1
Jeff Hao85139a32014-07-23 11:52:52 -0700480fi
481
Andreas Gampe1c83cbc2014-07-22 18:52:29 -0700482# Most interesting target architecture variables are Makefile variables, not environment variables.
Nicolas Geoffray6fbcc122014-07-24 00:36:48 +0100483# Try to map the suffix64 flag and what we find in ${ANDROID_PRODUCT_OUT}/data/art-test to an architecture name.
David Brazdil853a4c32015-09-28 16:15:50 +0100484function guess_target_arch_name() {
Nicolas Geoffray6fbcc122014-07-24 00:36:48 +0100485 grep32bit=`ls ${ANDROID_PRODUCT_OUT}/data/art-test | grep -E '^(arm|x86|mips)$'`
Andreas Gampe1a5c4062015-01-15 12:10:47 -0800486 grep64bit=`ls ${ANDROID_PRODUCT_OUT}/data/art-test | grep -E '^(arm64|x86_64|mips64)$'`
Andreas Gampe1c83cbc2014-07-22 18:52:29 -0700487 if [ "x${suffix64}" = "x64" ]; then
488 target_arch_name=${grep64bit}
489 else
490 target_arch_name=${grep32bit}
491 fi
492}
493
David Brazdil853a4c32015-09-28 16:15:50 +0100494function guess_host_arch_name() {
495 if [ "x${suffix64}" = "x64" ]; then
496 host_arch_name="x86_64"
497 else
498 host_arch_name="x86"
499 fi
500}
501
Alex Lighta59dd802014-07-02 16:28:08 -0700502if [ "$target_mode" = "no" ]; then
503 if [ "$runtime" = "jvm" ]; then
Alex Lighta59dd802014-07-02 16:28:08 -0700504 if [ "$prebuild_mode" = "yes" ]; then
Alex Light91de25f2015-10-28 17:00:06 -0700505 err_echo "--prebuild with --jvm is unsupported"
Alex Lighta59dd802014-07-02 16:28:08 -0700506 exit 1;
507 fi
Alex Lighta59dd802014-07-02 16:28:08 -0700508 fi
509fi
510
Alex Light03a112d2014-08-25 13:25:56 -0700511if [ "$have_patchoat" = "no" ]; then
512 run_args="${run_args} --no-patchoat"
513fi
514
515if [ "$have_dex2oat" = "no" ]; then
516 run_args="${run_args} --no-dex2oat"
517fi
518
Jeff Hao201803f2013-11-20 18:11:39 -0800519if [ ! "$runtime" = "jvm" ]; then
520 run_args="${run_args} --lib $lib"
521fi
Brian Carlstromdc959ea2013-10-28 00:44:49 -0700522
Jeff Hao201803f2013-11-20 18:11:39 -0800523if [ "$runtime" = "dalvik" ]; then
Brian Carlstromdc959ea2013-10-28 00:44:49 -0700524 if [ "$target_mode" = "no" ]; then
Nicolas Geoffray6fbcc122014-07-24 00:36:48 +0100525 framework="${ANDROID_PRODUCT_OUT}/system/framework"
Andreas Gampe50be66f2015-12-28 14:31:06 -0800526 bpath="${framework}/core-libart.jar:${framework}/core-oj.jar:${framework}/conscrypt.jar:${framework}/okhttp.jar:${framework}/bouncycastle.jar:${framework}/ext.jar"
Richard Uhler76f5cb62016-04-04 13:30:16 -0700527 run_args="${run_args} --boot --runtime-option -Xbootclasspath:${bpath}"
Brian Carlstromdc959ea2013-10-28 00:44:49 -0700528 else
529 true # defaults to using target BOOTCLASSPATH
530 fi
Jeff Hao201803f2013-11-20 18:11:39 -0800531elif [ "$runtime" = "art" ]; then
532 if [ "$target_mode" = "no" ]; then
David Brazdil853a4c32015-09-28 16:15:50 +0100533 guess_host_arch_name
Richard Uhlerbb00f812017-02-16 14:21:10 +0000534 run_args="${run_args} --boot ${ANDROID_HOST_OUT}/framework/core${image_suffix}${multi_image_suffix}.art"
Colin Crossafd3c9e2016-09-16 13:47:21 -0700535 run_args="${run_args} --runtime-option -Djava.library.path=${ANDROID_HOST_OUT}/lib${suffix64}:${ANDROID_HOST_OUT}/nativetest${suffix64}"
Jeff Hao201803f2013-11-20 18:11:39 -0800536 else
David Brazdil853a4c32015-09-28 16:15:50 +0100537 guess_target_arch_name
Dimitry Ivanov49c2c922017-02-14 11:06:14 -0800538 run_args="${run_args} --runtime-option -Djava.library.path=/data/nativetest${suffix64}/art/${target_arch_name}"
Richard Uhlerbb00f812017-02-16 14:21:10 +0000539 run_args="${run_args} --boot /data/art-test/core${image_suffix}${multi_image_suffix}.art"
Jeff Hao201803f2013-11-20 18:11:39 -0800540 fi
Alex Lighta59dd802014-07-02 16:28:08 -0700541 if [ "$relocate" = "yes" ]; then
542 run_args="${run_args} --relocate"
543 else
544 run_args="${run_args} --no-relocate"
545 fi
Andreas Gampe3f1dc562015-05-18 15:52:22 -0700546elif [ "$runtime" = "jvm" ]; then
547 # TODO: Detect whether the host is 32-bit or 64-bit.
Alex Lightfba89fe2017-01-12 16:11:02 -0800548 run_args="${run_args} --runtime-option -Djava.library.path=${ANDROID_HOST_OUT}/lib64:${ANDROID_HOST_OUT}/nativetest64"
Brian Carlstromdc959ea2013-10-28 00:44:49 -0700549fi
550
Alex Light03a112d2014-08-25 13:25:56 -0700551if [ "$have_image" = "no" ]; then
Alex Light1ef4ce82014-08-27 11:13:47 -0700552 if [ "$runtime" != "art" ]; then
Alex Light91de25f2015-10-28 17:00:06 -0700553 err_echo "--no-image is only supported on the art runtime"
Alex Light1ef4ce82014-08-27 11:13:47 -0700554 exit 1
555 fi
Alex Light03a112d2014-08-25 13:25:56 -0700556 run_args="${run_args} --no-image"
557fi
558
jeffhao5d1ac922011-09-29 17:41:15 -0700559if [ "$dev_mode" = "yes" -a "$update_mode" = "yes" ]; then
Alex Light91de25f2015-10-28 17:00:06 -0700560 err_echo "--dev and --update are mutually exclusive"
561 usage="yes"
562fi
563
564if [ "$dev_mode" = "yes" -a "$quiet" = "yes" ]; then
565 err_echo "--dev and --quiet are mutually exclusive"
jeffhao5d1ac922011-09-29 17:41:15 -0700566 usage="yes"
567fi
568
Wojciech Staszkiewiczd7a819a2016-09-01 14:43:39 -0700569if [ "$bisection_search" = "yes" -a "$prebuild_mode" = "yes" ]; then
570 err_echo "--bisection-search and --prebuild are mutually exclusive"
571 usage="yes"
572fi
573
574if [ "$bisection_search" = "yes" -a "$have_dex2oat" = "no" ]; then
575 err_echo "--bisection-search and --no-dex2oat are mutually exclusive"
576 usage="yes"
577fi
578
579if [ "$bisection_search" = "yes" -a "$have_patchoat" = "no" ]; then
580 err_echo "--bisection-search and --no-patchoat are mutually exclusive"
581 usage="yes"
582fi
583
jeffhao5d1ac922011-09-29 17:41:15 -0700584if [ "$usage" = "no" ]; then
585 if [ "x$1" = "x" -o "x$1" = "x-" ]; then
586 test_dir=`basename "$oldwd"`
587 else
588 test_dir="$1"
589 fi
590
591 if [ '!' -d "$test_dir" ]; then
592 td2=`echo ${test_dir}-*`
593 if [ '!' -d "$td2" ]; then
Alex Light91de25f2015-10-28 17:00:06 -0700594 err_echo "${test_dir}: no such test directory"
jeffhao5d1ac922011-09-29 17:41:15 -0700595 usage="yes"
596 fi
597 test_dir="$td2"
598 fi
jeffhao5d1ac922011-09-29 17:41:15 -0700599 # Shift to get rid of the test name argument. The rest of the arguments
600 # will get passed to the test run.
601 shift
602fi
603
Søren Gjesse620d0a52016-09-19 11:12:51 +0200604# For building with javac and dx always use Java 7. The dx compiler
605# only support byte codes from Java 7 or earlier (class file major
606# version 51 or lower).
607if [ "$USE_JACK" != "true" ] && [ "$NEED_DEX" = "true" ]; then
608 export JAVAC="${JAVAC} -source 1.7 -target 1.7"
609fi
610
jeffhao5d1ac922011-09-29 17:41:15 -0700611if [ "$usage" = "yes" ]; then
612 prog=`basename $prog`
613 (
614 echo "usage:"
615 echo " $prog --help Print this message."
616 echo " $prog [options] [test-name] Run test normally."
617 echo " $prog --dev [options] [test-name] Development mode" \
618 "(dumps to stdout)."
619 echo " $prog --update [options] [test-name] Update mode" \
620 "(replaces expected.txt)."
621 echo ' Omitting the test name or specifying "-" will use the' \
622 "current directory."
623 echo " Runtime Options:"
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000624 echo " -O Run non-debug rather than debug build (off by default)."
625 echo " -Xcompiler-option Pass an option to the compiler."
Orion Hodsone1fb77f2017-02-27 13:57:18 +0000626 echo " --build-option Pass an option to the build script."
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000627 echo " --runtime-option Pass an option to the runtime."
628 echo " --debug Wait for a debugger to attach."
Nicolas Geoffray43c162f2015-03-09 12:21:26 +0000629 echo " --debuggable Whether to compile Java code for a debugger."
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000630 echo " --gdb Run under gdb; incompatible with some tests."
Alex Lightfadfee92015-10-28 09:40:10 -0700631 echo " --gdb-arg Pass an option to gdb."
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000632 echo " --build-only Build test files only (off by default)."
Søren Gjesse620d0a52016-09-19 11:12:51 +0200633 echo " --build-with-javac-dx Build test files with javac and dx (off by default)."
634 echo " --build-with-jack Build test files with jack and jill (on by default)."
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000635 echo " --interpreter Enable interpreter only mode (off by default)."
Mathieu Chartiere5f13e52015-02-24 09:37:21 -0800636 echo " --jit Enable jit (off by default)."
Nicolas Geoffray0e071252015-03-21 13:43:15 +0000637 echo " --optimizing Enable optimizing compiler (default)."
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000638 echo " --no-verify Turn off verification (on by default)."
Igor Murashkin7617abd2015-07-10 18:27:47 -0700639 echo " --verify-soft-fail Force soft fail verification (off by default)."
640 echo " Verification is enabled if neither --no-verify"
641 echo " nor --verify-soft-fail is specified."
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000642 echo " --no-optimize Turn off optimization (on by default)."
643 echo " --no-precise Turn off precise GC (on by default)."
644 echo " --zygote Spawn the process from the Zygote." \
jeffhao5d1ac922011-09-29 17:41:15 -0700645 "If used, then the"
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000646 echo " other runtime options are ignored."
647 echo " --no-dex2oat Run as though dex2oat was failing."
648 echo " --no-patchoat Run as though patchoat was failing."
649 echo " --prebuild Run dex2oat on the files before starting test. (default)"
650 echo " --no-prebuild Do not run dex2oat on the files before starting"
651 echo " the test."
Richard Uhler76f5cb62016-04-04 13:30:16 -0700652 echo " --strip-dex Strip the dex files before starting test."
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000653 echo " --relocate Force the use of relocating in the test, making"
654 echo " the image and oat files be relocated to a random"
Nicolas Geoffray94e25db2017-01-27 14:54:28 +0000655 echo " address before running."
656 echo " --no-relocate Force the use of no relocating in the test. (default)"
Alex Lightfadfee92015-10-28 09:40:10 -0700657 echo " --image Run the test using a precompiled boot image. (default)"
658 echo " --no-image Run the test without a precompiled boot image."
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000659 echo " --host Use the host-mode virtual machine."
660 echo " --invoke-with Pass --invoke-with option to runtime."
661 echo " --dalvik Use Dalvik (off by default)."
662 echo " --jvm Use a host-local RI virtual machine."
Alex Lighteb7c1442015-08-31 13:17:42 -0700663 echo " --use-java-home Use the JAVA_HOME environment variable"
664 echo " to find the java compiler and runtime"
665 echo " (if applicable) to run the test with."
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000666 echo " --output-path [path] Location where to store the build" \
Tsu Chiang Chuang011fade2012-07-09 18:34:47 -0700667 "files."
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000668 echo " --64 Run the test in 64-bit mode"
669 echo " --trace Run with method tracing"
Alex Lightfadfee92015-10-28 09:40:10 -0700670 echo " --strace Run with syscall tracing from strace."
Andreas Gampe7526d782015-06-22 22:53:45 -0700671 echo " --stream Run method tracing in streaming mode (requires --trace)"
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000672 echo " --gcstress Run with gc stress testing"
673 echo " --gcverify Run with gc verification"
Alex Lightb7edcda2017-04-27 13:20:31 -0700674 echo " --jvmti-trace-stress Run with jvmti method tracing stress testing"
675 echo " --jvmti-redefine-stress"
676 echo " Run with jvmti method redefinition stress testing"
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000677 echo " --always-clean Delete the test files even if the test fails."
Igor Murashkin05f30e12015-06-10 15:57:17 -0700678 echo " --never-clean Keep the test files even if the test succeeds."
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000679 echo " --android-root [path] The path on target for the android root. (/system by default)."
Nicolas Geoffray43c162f2015-03-09 12:21:26 +0000680 echo " --dex2oat-swap Use a dex2oat swap file."
Andreas Gampe4d2ef332015-08-05 09:24:45 -0700681 echo " --instruction-set-features [string]"
682 echo " Set instruction-set-features for compilation."
Jeff Haodcdc85b2015-12-04 14:06:18 -0800683 echo " --multi-image Use a set of images compiled with dex2oat multi-image for"
684 echo " the boot class path."
Alex Lightfadfee92015-10-28 09:40:10 -0700685 echo " --pic-test Compile the test code position independent."
Alex Light91de25f2015-10-28 17:00:06 -0700686 echo " --quiet Don't print anything except failure messages"
Wojciech Staszkiewiczd7a819a2016-09-01 14:43:39 -0700687 echo " --bisection-search Perform bisection bug search."
Nicolas Geoffrayb0bbe8e2016-11-19 10:42:37 +0000688 echo " --vdex Test using vdex as in input to dex2oat. Only works with --prebuild."
Mathieu Chartier3fceaf52017-01-22 13:33:40 -0800689 echo " --suspend-timeout Change thread suspend timeout ms (default 500000)."
Alex Light91de25f2015-10-28 17:00:06 -0700690 ) 1>&2 # Direct to stderr so usage is not printed if --quiet is set.
jeffhao5d1ac922011-09-29 17:41:15 -0700691 exit 1
692fi
693
694cd "$test_dir"
695test_dir=`pwd`
696
697td_info="${test_dir}/${info}"
698td_expected="${test_dir}/${expected}"
699
Brian Carlstrom22469aa2012-09-07 10:34:57 -0700700if [ ! -r $td_info ]; then
Alex Light91de25f2015-10-28 17:00:06 -0700701 err_echo "${test_dir}: missing file $td_info"
Brian Carlstrom22469aa2012-09-07 10:34:57 -0700702 exit 1
703fi
704
705if [ ! -r $td_expected ]; then
Alex Light91de25f2015-10-28 17:00:06 -0700706 err_echo "${test_dir}: missing file $td_expected"
jeffhao5d1ac922011-09-29 17:41:15 -0700707 exit 1
708fi
709
710# copy the test to a temp dir and run it
711
Elliott Hughes510c8782011-10-06 10:57:34 -0700712echo "${test_dir}: building..." 1>&2
jeffhao5d1ac922011-09-29 17:41:15 -0700713
714rm -rf "$tmp_dir"
715cp -Rp "$test_dir" "$tmp_dir"
716cd "$tmp_dir"
717
718if [ '!' -r "$build" ]; then
719 cp "${progdir}/etc/default-build" build
Zheng Xuc6667102015-05-15 16:08:45 +0800720else
721 cp "${progdir}/etc/default-build" .
jeffhao5d1ac922011-09-29 17:41:15 -0700722fi
723
724if [ '!' -r "$run" ]; then
725 cp "${progdir}/etc/default-run" run
Zheng Xuc6667102015-05-15 16:08:45 +0800726else
727 cp "${progdir}/etc/default-run" .
jeffhao5d1ac922011-09-29 17:41:15 -0700728fi
729
Andreas Gampe1c83cbc2014-07-22 18:52:29 -0700730if [ '!' -r "$check_cmd" ]; then
731 cp "${progdir}/etc/default-check" check
Zheng Xuc6667102015-05-15 16:08:45 +0800732else
733 cp "${progdir}/etc/default-check" .
Andreas Gampe1c83cbc2014-07-22 18:52:29 -0700734fi
735
jeffhao5d1ac922011-09-29 17:41:15 -0700736chmod 755 "$build"
737chmod 755 "$run"
Andreas Gampe1c83cbc2014-07-22 18:52:29 -0700738chmod 755 "$check_cmd"
jeffhao5d1ac922011-09-29 17:41:15 -0700739
Elliott Hughes8cbc8bc2011-10-04 11:19:45 -0700740export TEST_NAME=`basename ${test_dir}`
741
David Brazdil4846d132015-01-15 19:07:08 +0000742# Tests named '<number>-checker-*' will also have their CFGs verified with
743# Checker when compiled with Optimizing on host.
744if [[ "$TEST_NAME" =~ ^[0-9]+-checker- ]]; then
Nicolas Geoffrayb76bc782016-09-14 12:33:34 +0000745 if [ "$runtime" = "art" -a "$image_suffix" = "" -a "$USE_JACK" = "true" ]; then
Nicolas Geoffrayf654ef92017-06-09 16:31:21 +0100746 # In no-prebuild or no-image mode, the compiler only quickens so disable the checker.
747 if [ "$prebuild_mode" = "yes" -a "$have_image" = "yes" ]; then
David Brazdil80fb3942015-07-23 11:53:42 +0100748 run_checker="yes"
David Brazdil5cc343d2015-10-08 11:35:32 +0100749
Alexandre Rames5e2c8d32015-08-06 14:49:28 +0100750 if [ "$target_mode" = "no" ]; then
751 cfg_output_dir="$tmp_dir"
David Brazdil5cc343d2015-10-08 11:35:32 +0100752 checker_args="--arch=${host_arch_name^^}"
Alexandre Rames5e2c8d32015-08-06 14:49:28 +0100753 else
754 cfg_output_dir="$DEX_LOCATION"
David Brazdil5cc343d2015-10-08 11:35:32 +0100755 checker_args="--arch=${target_arch_name^^}"
Alexandre Rames5e2c8d32015-08-06 14:49:28 +0100756 fi
David Brazdil5cc343d2015-10-08 11:35:32 +0100757
758 if [ "$debuggable" = "yes" ]; then
759 checker_args="$checker_args --debuggable"
760 fi
761
Alexandre Rames5e2c8d32015-08-06 14:49:28 +0100762 run_args="${run_args} -Xcompiler-option --dump-cfg=$cfg_output_dir/$cfg_output \
David Brazdil80fb3942015-07-23 11:53:42 +0100763 -Xcompiler-option -j1"
764 fi
David Brazdil4846d132015-01-15 19:07:08 +0000765 fi
766fi
767
Mathieu Chartier031768a2015-08-27 10:25:02 -0700768 run_args="${run_args} --testlib ${testlib}"
Mathieu Chartier031768a2015-08-27 10:25:02 -0700769
Richard Uhler020c0f32017-03-14 16:23:17 +0000770# To cause tests to fail fast, limit the file sizes created by dx, dex2oat and
771# ART output to approximately 128MB. This should be more than sufficient
772# for any test while still catching cases of runaway output.
773# Set a hard limit to encourage ART developers to increase the ulimit here if
774# needed to support a test case rather than resetting the limit in the run
775# script for the particular test in question.
Orion Hodsonbd328d32017-03-24 11:24:10 +0000776if ! ulimit -f 128000; then
Richard Uhler020c0f32017-03-14 16:23:17 +0000777 err_echo "ulimit file size setting failed"
Ian Rogers997f0f92014-06-21 22:58:05 -0700778fi
779
Igor Murashkin2a337752017-06-16 14:34:40 +0000780if [[ "$target_mode" == "yes" ]]; then
781 build_args="$build_args --target"
782else
783 build_args="$build_args --host"
784fi
785
786if [[ "$dev_mode" == "yes" ]]; then
787 build_args="$build_args --dev"
788fi
789
jeffhao5d1ac922011-09-29 17:41:15 -0700790good="no"
Nicolas Geoffray1ed097d2014-11-13 15:15:39 +0000791good_build="yes"
792good_run="yes"
jeffhao5d1ac922011-09-29 17:41:15 -0700793if [ "$dev_mode" = "yes" ]; then
David Brazdil4846d132015-01-15 19:07:08 +0000794 "./${build}" $build_args 2>&1
Elliott Hughes7ab3a2a2012-06-18 16:34:20 -0700795 build_exit="$?"
796 echo "build exit status: $build_exit" 1>&2
797 if [ "$build_exit" = '0' ]; then
Elliott Hughes2bfc6732012-11-27 20:40:51 -0800798 echo "${test_dir}: running..." 1>&2
799 "./${run}" $run_args "$@" 2>&1
Brian Carlstromdc959ea2013-10-28 00:44:49 -0700800 run_exit="$?"
Calin Juravle3cf48772015-01-26 16:47:33 +0000801
Brian Carlstrom700c8d32012-11-05 10:42:02 -0800802 if [ "$run_exit" = "0" ]; then
Calin Juravle3cf48772015-01-26 16:47:33 +0000803 if [ "$run_checker" = "yes" ]; then
Alexandre Rames5e2c8d32015-08-06 14:49:28 +0100804 if [ "$target_mode" = "yes" ]; then
805 adb pull $cfg_output_dir/$cfg_output &> /dev/null
806 fi
David Brazdil5cc343d2015-10-08 11:35:32 +0100807 "$checker" $checker_args "$cfg_output" "$tmp_dir" 2>&1
Calin Juravle3cf48772015-01-26 16:47:33 +0000808 checker_exit="$?"
809 if [ "$checker_exit" = "0" ]; then
810 good="yes"
811 fi
Alex Light91de25f2015-10-28 17:00:06 -0700812 err_echo "checker exit status: $checker_exit"
Calin Juravle3cf48772015-01-26 16:47:33 +0000813 else
814 good="yes"
815 fi
Brian Carlstrom700c8d32012-11-05 10:42:02 -0800816 fi
Calin Juravle3cf48772015-01-26 16:47:33 +0000817 echo "run exit status: $run_exit" 1>&2
Elliott Hughes7ab3a2a2012-06-18 16:34:20 -0700818 fi
jeffhao5d1ac922011-09-29 17:41:15 -0700819elif [ "$update_mode" = "yes" ]; then
David Brazdil4846d132015-01-15 19:07:08 +0000820 "./${build}" $build_args >"$build_output" 2>&1
jeffhao5d1ac922011-09-29 17:41:15 -0700821 build_exit="$?"
822 if [ "$build_exit" = '0' ]; then
Elliott Hughes2bfc6732012-11-27 20:40:51 -0800823 echo "${test_dir}: running..." 1>&2
jeffhao5d1ac922011-09-29 17:41:15 -0700824 "./${run}" $run_args "$@" >"$output" 2>&1
David Brazdil4846d132015-01-15 19:07:08 +0000825 if [ "$run_checker" = "yes" ]; then
Alexandre Rames5e2c8d32015-08-06 14:49:28 +0100826 if [ "$target_mode" = "yes" ]; then
827 adb pull $cfg_output_dir/$cfg_output &> /dev/null
828 fi
David Brazdil5cc343d2015-10-08 11:35:32 +0100829 "$checker" -q $checker_args "$cfg_output" "$tmp_dir" >> "$output" 2>&1
David Brazdil4846d132015-01-15 19:07:08 +0000830 fi
jeffhao5d1ac922011-09-29 17:41:15 -0700831 sed -e 's/[[:cntrl:]]$//g' < "$output" >"${td_expected}"
832 good="yes"
833 else
Alex Light91de25f2015-10-28 17:00:06 -0700834 cat "$build_output" 1>&${real_stderr} 1>&2
835 err_echo "build exit status: $build_exit"
jeffhao5d1ac922011-09-29 17:41:15 -0700836 fi
Tsu Chiang Chuang011fade2012-07-09 18:34:47 -0700837elif [ "$build_only" = "yes" ]; then
838 good="yes"
David Brazdil4846d132015-01-15 19:07:08 +0000839 "./${build}" $build_args >"$build_output" 2>&1
Tsu Chiang Chuang011fade2012-07-09 18:34:47 -0700840 build_exit="$?"
841 if [ "$build_exit" '!=' '0' ]; then
842 cp "$build_output" "$output"
843 echo "build exit status: $build_exit" >>"$output"
844 diff --strip-trailing-cr -q "$expected" "$output" >/dev/null
845 if [ "$?" '!=' "0" ]; then
846 good="no"
Alex Light91de25f2015-10-28 17:00:06 -0700847 err_echo "BUILD FAILED For ${TEST_NAME}"
Tsu Chiang Chuang011fade2012-07-09 18:34:47 -0700848 fi
849 fi
Tsu Chiang Chuang379e2f52013-08-20 12:24:52 -0700850 # Clean up extraneous files that are not used by tests.
Tsu Chiang Chuang0160d992013-09-13 14:17:42 -0700851 find $tmp_dir -mindepth 1 ! -regex ".*/\(.*jar\|$output\|$expected\)" | xargs rm -rf
Tsu Chiang Chuang011fade2012-07-09 18:34:47 -0700852 exit 0
jeffhao5d1ac922011-09-29 17:41:15 -0700853else
David Brazdil4846d132015-01-15 19:07:08 +0000854 "./${build}" $build_args >"$build_output" 2>&1
jeffhao5d1ac922011-09-29 17:41:15 -0700855 build_exit="$?"
856 if [ "$build_exit" = '0' ]; then
Elliott Hughes2bfc6732012-11-27 20:40:51 -0800857 echo "${test_dir}: running..." 1>&2
jeffhao5d1ac922011-09-29 17:41:15 -0700858 "./${run}" $run_args "$@" >"$output" 2>&1
Nicolas Geoffray1ed097d2014-11-13 15:15:39 +0000859 run_exit="$?"
860 if [ "$run_exit" != "0" ]; then
Alex Light91de25f2015-10-28 17:00:06 -0700861 err_echo "run exit status: $run_exit"
Nicolas Geoffray1ed097d2014-11-13 15:15:39 +0000862 good_run="no"
David Brazdil4846d132015-01-15 19:07:08 +0000863 elif [ "$run_checker" = "yes" ]; then
Alexandre Rames5e2c8d32015-08-06 14:49:28 +0100864 if [ "$target_mode" = "yes" ]; then
865 adb pull $cfg_output_dir/$cfg_output &> /dev/null
866 fi
David Brazdil5cc343d2015-10-08 11:35:32 +0100867 "$checker" -q $checker_args "$cfg_output" "$tmp_dir" >> "$output" 2>&1
David Brazdil4846d132015-01-15 19:07:08 +0000868 checker_exit="$?"
869 if [ "$checker_exit" != "0" ]; then
Alex Light91de25f2015-10-28 17:00:06 -0700870 err_echo "checker exit status: $checker_exit"
David Brazdil4846d132015-01-15 19:07:08 +0000871 good_run="no"
872 else
873 good_run="yes"
874 fi
Nicolas Geoffray1ed097d2014-11-13 15:15:39 +0000875 else
876 good_run="yes"
877 fi
jeffhao5d1ac922011-09-29 17:41:15 -0700878 else
Nicolas Geoffray1ed097d2014-11-13 15:15:39 +0000879 good_build="no"
jeffhao5d1ac922011-09-29 17:41:15 -0700880 cp "$build_output" "$output"
Andreas Gampef6930a82014-10-21 09:33:08 -0700881 echo "Failed to build in tmpdir=${tmp_dir} from oldwd=${oldwd} and cwd=`pwd`" >> "$output"
882 echo "Non-canonical tmpdir was ${noncanonical_tmp_dir}" >> "$output"
Ian Rogersd9ad27d2014-10-27 13:48:21 -0700883 echo "Args: ${args}" >> "$output"
Andreas Gampef6930a82014-10-21 09:33:08 -0700884 echo "build exit status: $build_exit" >> "$output"
Andreas Gampe5c114902014-10-27 17:03:58 -0700885 max_name_length=$(getconf NAME_MAX ${tmp_dir})
886 echo "Max filename (NAME_MAX): ${max_name_length}" >> "$output"
887 max_path_length=$(getconf PATH_MAX ${tmp_dir})
Andreas Gampe602fbcd2014-10-27 17:06:29 -0700888 echo "Max pathlength (PATH_MAX): ${max_path_length}" >> "$output"
jeffhao5d1ac922011-09-29 17:41:15 -0700889 fi
Andreas Gampe1c83cbc2014-07-22 18:52:29 -0700890 ./$check_cmd "$expected" "$output"
jeffhao5d1ac922011-09-29 17:41:15 -0700891 if [ "$?" = "0" ]; then
Nicolas Geoffray1ed097d2014-11-13 15:15:39 +0000892 if [ "$good_build" = "no" -o "$good_run" = "yes" ]; then
893 # output == expected
894 good="yes"
895 echo "${test_dir}: succeeded!" 1>&2
896 fi
jeffhao5d1ac922011-09-29 17:41:15 -0700897 fi
898fi
899
jeffhao5d1ac922011-09-29 17:41:15 -0700900(
Alex Lightbfac14a2014-07-30 09:41:21 -0700901 if [ "$good" != "yes" -a "$update_mode" != "yes" ]; then
jeffhao5d1ac922011-09-29 17:41:15 -0700902 echo "${test_dir}: FAILED!"
903 echo ' '
904 echo '#################### info'
905 cat "${td_info}" | sed 's/^/# /g'
906 echo '#################### diffs'
Hiroshi Yamauchid630fd62015-09-04 12:52:03 -0700907 diff --strip-trailing-cr -u "$expected" "$output" | tail -n 3000
jeffhao5d1ac922011-09-29 17:41:15 -0700908 echo '####################'
Hiroshi Yamauchi1d4184d2015-07-13 17:11:22 -0700909 if [ "$strace" = "yes" ]; then
910 echo '#################### strace output'
Hiroshi Yamauchid630fd62015-09-04 12:52:03 -0700911 tail -n 3000 "$tmp_dir/$strace_output"
Hiroshi Yamauchi1d4184d2015-07-13 17:11:22 -0700912 echo '####################'
913 fi
jeffhao5d1ac922011-09-29 17:41:15 -0700914 echo ' '
915 fi
Alex Lightbfac14a2014-07-30 09:41:21 -0700916
Alex Light91de25f2015-10-28 17:00:06 -0700917) 2>&${real_stderr} 1>&2
Alex Lightbfac14a2014-07-30 09:41:21 -0700918
Wojciech Staszkiewiczd7a819a2016-09-01 14:43:39 -0700919# Attempt bisection only if the test failed.
920if [ "$bisection_search" = "yes" -a "$good" != "yes" ]; then
921 # Bisecting works by skipping different optimization passes which breaks checker assertions.
922 if [ "$run_checker" == "yes" ]; then
923 echo "${test_dir}: not bisecting, checker test." 1>&2
924 else
925 # Increase file size limit, bisection search can generate large logfiles.
Wojciech Staszkiewiczd7a819a2016-09-01 14:43:39 -0700926 echo "${test_dir}: bisecting..." 1>&2
927 cwd=`pwd`
928 maybe_device_mode=""
929 raw_cmd=""
930 if [ "$target_mode" = "yes" ]; then
931 # Produce cmdline.sh in $DEX_LOCATION. "$@" is passed as a runtime option
932 # so that cmdline.sh forwards its arguments to dalvikvm. invoke-with is set
933 # to exec in order to preserve pid when calling dalvikvm. This is required
934 # for bisection search to correctly retrieve logs from device.
935 "./${run}" $run_args --runtime-option '"$@"' --invoke-with exec --dry-run "$@" &> /dev/null
936 adb shell chmod u+x "$DEX_LOCATION/cmdline.sh"
937 maybe_device_mode="--device"
938 raw_cmd="$DEX_LOCATION/cmdline.sh"
939 else
940 raw_cmd="$cwd/${run} --external-log-tags $run_args $@"
941 fi
942 $ANDROID_BUILD_TOP/art/tools/bisection_search/bisection_search.py \
943 $maybe_device_mode \
944 --raw-cmd="$raw_cmd" \
945 --check-script="$cwd/check" \
946 --expected-output="$cwd/expected.txt" \
Wojciech Staszkiewicz0c883832016-09-26 17:51:52 -0700947 --logfile="$cwd/bisection_log.txt" \
Wojciech Staszkiewiczd7a819a2016-09-01 14:43:39 -0700948 --timeout=300
949 fi
950fi
951
Alex Lightbfac14a2014-07-30 09:41:21 -0700952# Clean up test files.
Igor Murashkin05f30e12015-06-10 15:57:17 -0700953if [ "$always_clean" = "yes" -o "$good" = "yes" ] && [ "$never_clean" = "no" ]; then
Alex Lightbfac14a2014-07-30 09:41:21 -0700954 cd "$oldwd"
955 rm -rf "$tmp_dir"
956 if [ "$target_mode" = "yes" -a "$build_exit" = "0" ]; then
957 adb shell rm -rf $DEX_LOCATION
958 fi
959 if [ "$good" = "yes" ]; then
960 exit 0
961 fi
962fi
963
964
965(
966 if [ "$always_clean" = "yes" ]; then
967 echo "${TEST_NAME} files deleted from host "
968 if [ "$target_mode" == "yes" ]; then
969 echo "and from target"
970 fi
971 else
972 echo "${TEST_NAME} files left in ${tmp_dir} on host"
973 if [ "$target_mode" == "yes" ]; then
974 echo "and in ${DEX_LOCATION} on target"
975 fi
Brian Carlstrom105215d2012-06-14 12:50:44 -0700976 fi
977
Alex Light91de25f2015-10-28 17:00:06 -0700978) 2>&${real_stderr} 1>&2
jeffhao5d1ac922011-09-29 17:41:15 -0700979
Alex Light6a870fa2016-05-31 16:36:19 -0700980if [ "$never_clean" = "yes" ] && [ "$good" = "yes" ]; then
981 exit 0
982else
983 exit 1
984fi